//% color="#00c4dd" iconWidth=50 iconHeight=40
namespace unihiker_sound{

    //% block="行空板音量设置为[SOUND]%" blockType="command" 
    ///% SOUND.shadow="range"   SOUND.params.min=0    SOUND.params.max=100    SOUND.defl=50
    export function unihiker_setsound_init(parameter: any, block: any){
        let SOUND = parameter.SOUND.code;
        Generator.addImport("import os");

        Generator.addDeclaration("unihiker_setsound_init",`
def set_sound(sound_value):
    sound_value = max(0, min(100, sound_value))
    os.system("amixer -c 2 set PCM {}% > /dev/null".format(sound_value))`)
    Generator.addCode(`set_sound(${SOUND})`)


    }

    
    //% block="获取行空板音量" blockType="reporter"
    export function unihiker_getsound(parameter: any, block: any){
        Generator.addImport("import subprocess\nimport re");
        Generator.addDeclaration("unihiker_getsound",`
def get_sound():
    try:
        result = subprocess.run(["amixer", "-c", "2", "get", "PCM"], stdout=subprocess.PIPE, text=True)
        matches = re.findall(r'\\[(\\d+)%\\]', result.stdout)
        if matches:
            volume = matches[0]
            return int(volume)
        else:
            return None
    except Exception as e:
        print("获取声卡音量失败:", e)
        return None`)
        Generator.addCode(`get_sound()`)
    }


}